#Compile Exe    "Simplest"   '''Simplest.bas
#Include        "Win32api.inc"
Global strLines() As String   'Array to hold lines to be scrolled.
%LAST_LINE  = 15              'Highest zero based array position holding text data.

Type WndEventArgs             'This type will be declared as static in the window procedure
  hIns As Dword               'and will be passed to the various message handling functions.
  hWnd As Dword               'In that way several variables critical to the development of
  wParam As Dword             'scroll logic such as the minimum and maximum scroll bar
  lParam As Dword             'positions will maintain their values between function calls.
  cyChar As Long
  iBegin As Long
  iEnd As Long
  iCtVisLns As Long
  iCtTotLns As Long
End Type


Function fnWndProc_OnCreate(wea As WndEventArgs) As Long
  Local tm As TEXTMETRIC
  Register i As Long
  Local hDC As Long
  Local rc As RECT

  ReDim strLines(%LAST_LINE) As String
  For i = 0 To %LAST_LINE
    strLines(i)=Str$(i) & "  " & _
    "PowerBASIC Scrolling Demonstration (Simplest)"
  Next i
  hDC=GetDC(wea.hWnd)               'In Windows, you need something called a 'Device Context' to get
  Call GetTextMetrics(hDC,tm)       'info on how things such as text will be displayed.  To find out
  wea.cyChar=tm.tmHeight            'how many lines of text will be visible on any screen size chosen
  Call ReleaseDC(wea.hWnd,hDC)      'by a user, we need the height of a character, 'wea.cyChar'.
  Call GetClientRect(wea.hWnd,rc)   'wea.hWnd is an 'input' parameter, rc is an 'output' parameter
  wea.iBegin=0                      'and its members will contain size of client area of window.
  wea.iEnd=rc.nBottom\wea.cyChar-1  'Subtract 1 from wea.iCtVisLns to account for zero based strLines()
  wea.iCtTotLns=%LAST_LINE+1        'array
  wea.iCtVisLns=rc.nBottom\wea.cyChar
  Call SetScrollRange(wea.hWnd,%SB_VERT,0,wea.iCtTotLns-wea.iCtVisLns,%FALSE)

  fnWndProc_OnCreate=0
End Function


Function fnWndProc_OnVScroll(wea As WndEventArgs) As Long
  Select Case LoWrd(wea.wParam)
    Case %SB_LINEUP
      Decr wea.iBegin
      If wea.iBegin < 0 Then
         wea.iBegin = 0
      End If
      wea.iEnd=wea.iBegin+wea.iCtVisLns-1
      Call SetScrollPos(wea.hWnd,%SB_VERT,wea.iBegin,%TRUE)
      Call InvalidateRect(wea.hWnd,ByVal %NULL,%TRUE)
    Case %SB_LINEDOWN
      Incr wea.iBegin
      If wea.iBegin > wea.iCtTotLns-wea.iCtVisLns Then
        wea.iBegin=wea.iCtTotLns-wea.iCtVisLns
      End If
      wea.iEnd=wea.iBegin+wea.iCtVisLns-1
      Call SetScrollPos(wea.hWnd,%SB_VERT,wea.iBegin,%TRUE)
      Call InvalidateRect(wea.hWnd,ByVal %NULL,%FALSE)
  End Select

  fnWndProc_OnVScroll = 0
End Function


Function fnWndProc_OnPaint(wea As WndEventArgs) As Long
  Local hDC As Long,y As Long
  Local LpPaint As PAINTSTRUCT
  Register i As Long

  hDC = BeginPaint(wea.hWnd, LpPaint)
  For i = wea.iBegin To wea.iEnd
    Call TextOut(hDC,0,y*16,ByVal StrPtr(strLines(i)),Len(strLines(i)))
    Incr y
  Next i
  Call EndPaint(wea.hWnd,LpPaint)

  fnWndProc_OnPaint=0
End Function


Function fnWndProc_OnClose(wea As WndEventArgs) As Long
  Erase strLines()
  Call PostQuitMessage(0)

  fnWndProc_OnClose=0
End Function


Function fnWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Static wea As WndEventArgs

  Select Case wMsg
    Case %WM_CREATE
      wea.hWnd=hWnd : wea.wParam=wParam : wea.lParam=lParam
      fnWndProc = fnWndProc_OnCreate(wea)
      Exit Function
    Case %WM_VSCROLL
      wea.hWnd=hWnd : wea.wParam=wParam : wea.lParam=lParam
      fnWndProc=fnWndProc_OnVScroll(wea)
      Exit Function
    Case %WM_PAINT
      wea.hWnd=hWnd : wea.wParam=wParam : wea.lParam=lParam
      fnWndProc=fnWndProc_OnPaint(wea)
      Exit Function
    Case %WM_CLOSE
      wea.hWnd=hWnd : wea.wParam=wParam : wea.lParam=lParam
      fnWndProc=fnWndProc_OnClose(wea)
      Exit Function
  End Select

  fnWndProc=DefWindowProc(hWnd, wMsg, wParam, lParam)
End Function


Function WinMain(ByVal hIns As Long, ByVal hPrev As Long,ByVal lpCL As Asciiz Ptr, ByVal Is As Long) As Long
  Local hMainWnd As Dword,dwStyle As Dword
  Local winclass As WndClassEx
  Local szAppName As Asciiz*16
  Local Msg As tagMsg

  szAppName="Simplest.bas"
  winclass.cbSize=SizeOf(winclass)                       :winclass.style=%CS_HREDRAW Or %CS_VREDRAW
  winclass.lpfnWndProc=CodePtr(fnWndProc)                :winclass.cbClsExtra=0
  winclass.cbWndExtra=0                                  :winclass.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)
  winclass.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION) :winclass.hInstance=hIns
  winclass.hbrBackground=GetStockObject(%WHITE_BRUSH)    :winclass.lpszMenuName=%NULL
  winclass.lpszClassName=VarPtr(szAppName)               :winclass.hIconSm=0
  Call RegisterClassEx(winclass)
  dwStyle=%WS_CAPTION Or %WS_MINIMIZEBOX Or %WS_VISIBLE Or %WS_VSCROLL Or %WS_SYSMENU
  hMainWnd=CreateWindowEx(0,szAppName,szAppName,dwStyle,200,100,375,206,0,0,hIns,ByVal 0)
  Call ShowWindow(hMainWnd,Is)
  Call UpdateWindow(hMainWnd)
  While GetMessage(Msg,%NULL,0,0)
    TranslateMessage Msg
    DispatchMessage Msg
  Wend

  Function=msg.wParam
End Function
